/*
* 
*   Podprogramy pre pracu s retazcami
*
*/



//*--------------------------------------------------------------------------------------
// Zistenie dlzky retazca
//*--------------------------------------------------------------------------------------
int strlen(unsigned char *s)
{ int i=0;

  while(1)
  { if (s[i] == 0)
      return i;
    i++; 
  }   
}

//*--------------------------------------------------------------------------------------
// Pripojenie retazca s (source) ku retazcu d (destination) aj s ukoncujucou nulou
//*--------------------------------------------------------------------------------------
void strcat(unsigned char *d, unsigned char *s)
{ int ld, ls, i;

  ld = strlen(d);  
  ls = strlen(s);  
  
  for(i=0;i<ls+1;i++)
    d[ld+i] = s[i];
}

//*--------------------------------------------------------------------------------------
// Pripojenie casti retazca s (source) ku retazcu d (destination) aj s ukoncujucou nulou
// Pripoji sa n znakov
//*--------------------------------------------------------------------------------------
void strncat(unsigned char *d, unsigned char *s, unsigned int n)
{ int ld, i;

  ld = strlen(d);  
  
  for(i=0;i<n;i++)
    d[ld+i] = s[i];
  d[ld+i] = 0;
}

//*--------------------------------------------------------------------------------------
// Skopirovanie retazca s (source) do retazca d (destination) aj s ukoncujucou nulou
//*--------------------------------------------------------------------------------------
void strcpy(unsigned char *d, unsigned char *s)
{ int ls, i;

  ls = strlen(s);  
  
  for(i=0;i<ls+1;i++)
    d[i] = s[i];
}

//*--------------------------------------------------------------------------------------
// Porovnanie dvoch retazcov
// vrati 0 ak sa retazce rovnaju
//*--------------------------------------------------------------------------------------
int strcmp(unsigned char *d, unsigned char *s)
{ int ld, ls, i;

  ld = strlen(d);  
  ls = strlen(s);  

  if (ld != ls) 
    return(1);
  
  for(i=0;i<ls;i++)
   if (d[i] != s[i])
     return(1);

  return(0);
}

//*--------------------------------------------------------------------------------------
// Porovnanie casti dvoch retazcov
// vrati 0 ak sa retazce rovnaju
//*--------------------------------------------------------------------------------------
int strncmp(unsigned char *d, unsigned char *s, int poc)
{ int i;

  if (strlen(d) < poc || strlen(s) < poc) 
    return(1);
  
  for(i=0;i<poc;i++)
   if (d[i] != s[i])
     return(1);

  return(0);
}


//*--------------------------------------------------------------------------------------
// Konverzia int na retazec
//*--------------------------------------------------------------------------------------
void itoa(char *d, int c)
{ int z1,z2,z3,z4;

  z1 = c/1000;
  z2 = (c-z1*1000)/100;
  z3 = (c-z1*1000-z2*100)/10;
  z4 = c-z1*1000-z2*100-z3*10;

  d[0]=z1+0x30;
  d[1]=z2+0x30;
  d[2]=z3+0x30;
  d[3]=z4+0x30;
  d[4]=0;
}
